#include <iostream>
#include <iomanip>  // necessário para métodos setf() de cin e ostream's

using namespace std;

#ifndef MAT_TYPE
#define MAT_TYPE int
#endif

class Matrix {
  int linhas, colunas;
  MAT_TYPE **mat;

public:
  Matrix();
  Matrix(int lins, int cols);
  Matrix(MAT_TYPE **newmat, int lins, int cols);
  MAT_TYPE* operator [](const int j) const;
    
  // Funções são amigas, mas não são parte da classe.
  friend istream& operator >>(istream& s, Matrix& m);
  friend ostream& operator <<(ostream& s, Matrix& m);

  friend Matrix add (const Matrix& mat1, const Matrix& mat2, char op);
  friend Matrix operator +(const Matrix& mat1, const Matrix& mat2);
  friend Matrix operator -(const Matrix& mat1, const Matrix& mat2);

  friend Matrix operator *(const Matrix& mat1, const Matrix& mat2);
  friend Matrix operator *(const Matrix& mat1, const float escalar);
  friend Matrix operator *(const float escalar, const Matrix& mat1);
};
